
-- by "Marhu" 
-- v 1.0
-- Date: 13.02.2013
-- Strohkanone

					
BallenWurf = {};

function BallenWurf.prerequisitesPresent(specializations)
    return true
end;

function BallenWurf:load(xmlFile)
	
	self.Strom = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.Strom#index"));
	self.Rohr45vis = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.Rohr45#index"));
	self.Rohr30vis = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.Rohr30#index"));
	self.BalePos = getChildAt(self.Strom,0)
	self.Pusher = getChildAt(self.Strom,1)
	self.scanRefR = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.scanRefR#index"));
	self.scanRefL = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.scanRefL#index"));
	self.TrichterPos = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.TrichterPos#index"));
	self.KammerPos = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.KammerPos#index"));
	
	self.transTime = 0.45 * 1000
	
	self.searchBale = BallenWurf.searchBale;
	self.isBaleInRange = BallenWurf.isBaleInRange;
	self.FarmerAni = BallenWurf.FarmerAni;
	self.FarmerAniReset = BallenWurf.FarmerAniReset;
	
	self.GrabBale = g_currentMission.time - 1
	self.ScanBaleT = g_currentMission.time - 1
	
	self.Sounds = {}
	local SoundRefNode = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.SoundGeblaeseS#node"));
	local workSound  = getXMLString(xmlFile, "vehicle.SoundGeblaeseS#file");
	if workSound  ~= nil and workSound  ~= "" then
		workSound  = Utils.getFilename(workSound, self.baseDirectory);
		self.workSoundRadius = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.workSound#radius"), 50);
		self.workSoundInnerRadius = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.workSound#innerRadius"), 10);
		self.workSoundVolume = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.workSound#volume"), 1);
		self.Sounds.GS = createAudioSource("GSSound", workSound, self.workSoundRadius, self.workSoundInnerRadius, self.workSoundVolume, 1);
		setVisibility(self.Sounds.GS, false);
		link(SoundRefNode, self.Sounds.GS);
		self.Sounds.GSSa = getAudioSourceSample(self.Sounds.GS)
		--self.Sounds.GS = getAudioSourceSample(source)
		--stopSample(self.Sounds.GS)
	end;
	workSound  = getXMLString(xmlFile, "vehicle.SoundGeblaeseI#file");
	if workSound  ~= nil and workSound  ~= "" then
		workSound  = Utils.getFilename(workSound, self.baseDirectory);
		self.Sounds.GI = createAudioSource("GISound", workSound, self.workSoundRadius, self.workSoundInnerRadius, self.workSoundVolume, 0);
		setVisibility(self.Sounds.GI, false);
		link(SoundRefNode, self.Sounds.GI);
		self.Sounds.GISa = getAudioSourceSample(self.Sounds.GI)
		--stopSample(self.Sounds.GI)
	end;
	workSound  = getXMLString(xmlFile, "vehicle.SoundGeblaeseO#file");
	if workSound  ~= nil and workSound  ~= "" then
		workSound  = Utils.getFilename(workSound, self.baseDirectory);
		self.Sounds.GO  = createAudioSource("GOSound", workSound, self.workSoundRadius, self.workSoundInnerRadius, self.workSoundVolume, 1);
		setVisibility(self.Sounds.GO, false);
		link(SoundRefNode, self.Sounds.GO);
		self.Sounds.GOSa = getAudioSourceSample(self.Sounds.GO)
		--stopSample(self.Sounds.GO)
	end;
	SoundRefNode = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.SoundWusch#node"));
	workSound  = getXMLString(xmlFile, "vehicle.SoundWusch#file");
	if workSound  ~= nil and workSound  ~= "" then
		workSound  = Utils.getFilename(workSound, self.baseDirectory);
		self.Sounds.Wusch = createAudioSource("Wusch", workSound, self.workSoundRadius, self.workSoundInnerRadius, self.workSoundVolume, 1);
		setVisibility(self.Sounds.Wusch, false);
		link(SoundRefNode, self.Sounds.Wusch);
		self.Sounds.WuschSa = getAudioSourceSample(self.Sounds.Wusch)
		--stopSample(self.Sounds.Wusch)
		
	end;
	
end;

function BallenWurf:delete()
	
end;

function BallenWurf:mouseEvent(posX, posY, isDown, isUp, button)
end;

function BallenWurf:keyEvent(unicode, sym, modifier, isDown)
end;

function BallenWurf:update(dt)
	
		
	self.InputActive = false
	if self:getIsActiveForInput() then
		self.InputActive = true
	else
		if g_currentMission.player ~= nil then
			local pvx, pvy, pvz = getWorldTranslation(g_currentMission.player.rootNode);
			local x1, y1, z1 = getWorldTranslation(self.scanRefR);
			local x2, y2, z2 = getWorldTranslation(self.scanRefL);
			local farmerDistance1 = Utils.vector3Length(pvx-x1, pvy-y1, pvz-z1);
			local farmerDistance2 = Utils.vector3Length(pvx-x2, pvy-y2, pvz-z2);
			--print(farmerDistance1," ",farmerDistance2)
			if farmerDistance1 < 5 or farmerDistance2 < 5 then
				self.InputActive = true
				g_currentMission:addHelpButtonText(g_i18n:getText("StrohkanoneRauf"), InputBinding.Strohkanone_RAUF);
				g_currentMission:addHelpButtonText(g_i18n:getText("StrohkanoneRunter"), InputBinding.Strohkanone_RUNTER);
				if self.IsOn then
					g_currentMission:addHelpButtonText(string.format("%s %d",g_i18n:getText("StrohkanoneAus"),self.transTime ), InputBinding.Strohkanone_ONOFF);
				else
					g_currentMission:addHelpButtonText(string.format("%s %d",g_i18n:getText("StrohkanoneAn"),self.transTime ), InputBinding.Strohkanone_ONOFF);
					if self.Rohr30 then
						g_currentMission:addHelpButtonText(string.format("%s %d",g_i18n:getText("RohrWechsel"),45), InputBinding.Strohkanone_ROHR);
					else
						g_currentMission:addHelpButtonText(string.format("%s %d",g_i18n:getText("RohrWechsel"),30), InputBinding.Strohkanone_ROHR);
					end
				end
			end;
		end;
	end
	
	if self.InputActive then
		if InputBinding.hasEvent(InputBinding.Strohkanone_ONOFF) then
			self.IsOn = not self.IsOn
			if self.IsOn then
				local pitch = ((self.transTime-200)/800)+0.5
				setSamplePitch(self.Sounds.GISa,pitch)
				setSamplePitch(self.Sounds.GSSa,pitch)
			else
				
			end
		end
		if InputBinding.isPressed(InputBinding.Strohkanone_RAUF) then
			self.transTime = math.min(1000,self.transTime + 10)
			local pitch = ((self.transTime-200)/800)+0.5
			setSamplePitch(self.Sounds.GISa,pitch)
			setSamplePitch(self.Sounds.GSSa,pitch)
		elseif InputBinding.isPressed(InputBinding.Strohkanone_RUNTER) then
			self.transTime = math.max(200,self.transTime - 10)
			local pitch = ((self.transTime-200)/800)+0.5
			setSamplePitch(self.Sounds.GISa,pitch)
			setSamplePitch(self.Sounds.GSSa,pitch)
		end
		if not self.IsOn and InputBinding.hasEvent(InputBinding.Strohkanone_ROHR) then
			local rx,ry,rz = getRotation(self.Strom);
			if self.Rohr30 then
				setRotation(self.Strom,math.rad(-45),ry,rz);
				self.Rohr30 = nil
				setVisibility(self.Rohr30vis, false)
				setVisibility(self.Rohr45vis, true)
			else
				setRotation(self.Strom,math.rad(-30),ry,rz);
				self.Rohr30 = true
				setVisibility(self.Rohr30vis, true)
				setVisibility(self.Rohr45vis, false)
			end
			
		end
	end
	
	if self.IsOn then
		if not self.SoundOn then
			self.SoundOn = true
			playSample(self.Sounds.GSSa, 1, 1, 0);
			setVisibility(self.Sounds.GS, true)
		elseif not self.SoundI and ( not isSamplePlaying(self.Sounds.GSSa) or getSamplePlayOffset(self.Sounds.GSSa) >= getSampleDuration(self.Sounds.GSSa)-10*dt) then
			setVisibility(self.Sounds.GS, false)
			setVisibility(self.Sounds.GI, true)
			self.SoundI = true
		end
	elseif self.SoundOn then
		setVisibility(self.Sounds.GS,false)
		self.SoundOn = nil
		if self.SoundI then
			setVisibility(self.Sounds.GI, false)
			self.SoundI = false
			playSample(self.Sounds.GOSa, 1, 1, 0);
			setVisibility(self.Sounds.GO, true)
		end
	end
end;

function BallenWurf:updateTick(dt)
	
				
	if self.IsOn then
		
		if self.haveBale then
			local nearestDistance = 7;
			local x,y,z = getWorldTranslation(self.BalePos);
			local bx, by, bz = getWorldTranslation(self.haveBale);
			local distance = Utils.vector3Length(x-bx, y-by, z-bz);
			if distance > nearestDistance then
				self.haveBale = nil
				self.wuschplay = false
			elseif not self.wuschplay then
				playSample(self.Sounds.WuschSa, 1, 1, 0);
				setVisibility(self.Sounds.Wusch, true);
				self.wuschplay = true
			end
			local deltaRealTime = dt/self.transTime
			local x,y,z = getWorldTranslation(self.BalePos);
			local lx, ly, lz = getWorldTranslation(self.Pusher);
			setLinearVelocity(self.haveBale, (x-lx)/deltaRealTime, (y-ly)/deltaRealTime, (z-lz)/deltaRealTime);
		end
		
		if not self.TrichterBale and self.ScanBaleT <= g_currentMission.time then
			self:searchBale()
		elseif false and self.ScanBale and not self.TrichterBale and self.ScanBaleT <= g_currentMission.time then
			local x,y,z = getWorldTranslation(self.TrichterPos);
			local rx,ry,rz = getWorldRotation(self.TrichterPos);
			setTranslation(self.ScanBale,x,y,z );
			setRotation(self.ScanBale, rx,ry,rz);
			self.TrichterBale = self.ScanBale
			self.ScanBale = nil
			self.ScanBaleT = g_currentMission.time + 1000
		elseif self.TrichterBale and not self.haveBale and self.ScanBaleT <= g_currentMission.time then
			local deltaRealTime = dt/100
			local x,y,z = getWorldTranslation(self.KammerPos);
			local lx, ly, lz = getWorldTranslation(self.TrichterBale);
			setLinearVelocity(self.TrichterBale, (x-lx)/deltaRealTime, (y-ly)/deltaRealTime, (z-lz)/deltaRealTime);
			local distance = Utils.vector3Length(x-lx, y-ly, z-lz);
			if distance <= 1.5 then
				local x,y,z = getWorldTranslation(self.BalePos);
				local rx,ry,rz = getWorldRotation(self.BalePos);
				setTranslation(self.TrichterBale,x,y,z );
				setRotation(self.TrichterBale, rx,ry,rz);
				self.haveBale = self.TrichterBale
				self.TrichterBale = nil
				
			end
			
			
		end
		
		if self.attacherVehicle and (self.attacherVehicle.lastSpeed*3600) >= 1 then
			self.IsOn = false
		end
		
	elseif self.TrichterBale then
		local x,y,z = getWorldTranslation(self.scanRefR);
		local rx,ry,rz = getWorldRotation(self.scanRefR);
		setTranslation(self.TrichterBale,x,y,z );
		setRotation(self.TrichterBale, rx,ry,rz);
		self.TrichterBale = nil
	elseif self.haveBale then
		local x,y,z = getWorldTranslation(self.scanRefL);
		local rx,ry,rz = getWorldRotation(self.scanRefL);
		setTranslation(self.haveBale,x,y,z );
		setRotation(self.haveBale, rx,ry,rz);
		self.haveBale = nil
	end
	
end

function BallenWurf:draw()
	if self:getIsActiveForInput() then
		g_currentMission:addHelpButtonText(g_i18n:getText("StrohkanoneRauf"), InputBinding.Strohkanone_RAUF);
		g_currentMission:addHelpButtonText(g_i18n:getText("StrohkanoneRunter"), InputBinding.Strohkanone_RUNTER);
		if self.IsOn then
			g_currentMission:addHelpButtonText(string.format("%s %d",g_i18n:getText("StrohkanoneAus"),self.transTime ), InputBinding.Strohkanone_ONOFF);
		else
			g_currentMission:addHelpButtonText(string.format("%s %d",g_i18n:getText("StrohkanoneAn"),self.transTime ), InputBinding.Strohkanone_ONOFF);
			g_currentMission:addHelpButtonText(g_i18n:getText("RohrWechsel"), InputBinding.Strohkanone_ROHR);
		end
	end
end;

function BallenWurf:onAttach()

end; 

function BallenWurf:onDetach()
	
end;

function BallenWurf:getSaveAttributesAndNodes(nodeIdent)

	
	local attributes = ""
	
	
	return attributes, nil;
end

function BallenWurf:loadFromAttributesAndNodes(xmlFile, key, resetVehicles)
	
	return BaseMission.VEHICLE_LOAD_OK;
end

function BallenWurf:isBaleInRange(place,object)
	local nearestDistance = 5;
	local x, y, z = getWorldTranslation(place);
	local bx, by, bz = getWorldTranslation(object);
	local distance = Utils.vector3Length(x-bx, y-by, z-bz);
	if distance < nearestDistance then
		return true
	else
		return false
	end
end;

function BallenWurf:searchBale()
	
	for index,item in pairs(g_currentMission.itemsToSave) do
		if item.item:isa(Bale) then 
			local isInRange = self:isBaleInRange(self.scanRefR,item.item.nodeId);		
			if not isInRange then
				isInRange = self:isBaleInRange(self.scanRefL,item.item.nodeId);		
			end
			if isInRange then
				local x,y,z = getWorldTranslation(self.TrichterPos);
				local rx,ry,rz = getWorldRotation(self.TrichterPos);
				setTranslation(item.item.nodeId,x,y,z );
				setRotation(item.item.nodeId, rx,ry,rz);
				self.TrichterBale = item.item.nodeId
				self.ScanBaleT = g_currentMission.time + 1000
				break
			end
		end;
	end;
	
end;


function BallenWurf:FarmerAni(ani,dir,dt)
	
end

function BallenWurf:FarmerAniReset(dt,winkel)
	
end
